# Class SanitizeUriProvider

#### Description

Private service to sanitize uris for links and images. Used by $compile.

- Defined in core/sanitize/sanitize-uri.js:9

#####
Index

### Constructors

constructor

### Properties

$get
aHrefSanitizationTrustedUrlList
imgSrcSanitizationTrustedUrlList

##
Constructors

### constructor

- new SanitizeUriProvider(): SanitizeUriProvider

- #### Returns SanitizeUriProvider

  #### Description

  Private service to sanitize uris for links and images. Used by $compile.

  - Defined in core/sanitize/sanitize-uri.js:9

##
Properties

### $get

$get: (() => ((uri: any, isMediaUrl: any) => any))

- Defined in core/sanitize/sanitize-uri.js:71

### aHrefSanitizationTrustedUrlList

aHrefSanitizationTrustedUrlList: ((regexp: RegExp) => RegExp | SanitizeUriProvider)

#### Type declaration

- - (regexp): RegExp | SanitizeUriProvider

  - #### Parameters

    - regexp: RegExp

      New regexp to trust urls with.

    #### Returns RegExp | SanitizeUriProvider

    Current RegExp if called without value or self for chaining otherwise.

#### Description

Retrieves or overrides the default regular expression that is used for determining trusted safe urls during a[href] sanitization.

The sanitization is a security measure aimed at prevent XSS attacks via HTML anchor links.

Any url due to be assigned to an `a[href]` attribute via interpolation is marked as requiring the $sce.URL security context. When interpolation occurs a call is made to `$sce.trustAsUrl(url)` which in turn may call `$$sanitizeUri(url, isMedia)` to sanitize the potentially malicious URL.

If the URL matches the `aHrefSanitizationTrustedUrlList` regular expression, it is returned unchanged.

If there is no match the URL is returned prefixed with `'unsafe:'` to ensure that when it is written to the DOM it is inactive and potentially malicious code will not be executed.

- Defined in core/sanitize/sanitize-uri.js:34

### imgSrcSanitizationTrustedUrlList

imgSrcSanitizationTrustedUrlList: ((regexp: RegExp) => RegExp | SanitizeUriProvider)

#### Type declaration

- - (regexp): RegExp | SanitizeUriProvider

  - #### Parameters

    - regexp: RegExp

      New regexp to trust urls with.

    #### Returns RegExp | SanitizeUriProvider

    Current RegExp if called without value or self for chaining otherwise.

#### Description

Retrieves or overrides the default regular expression that is used for determining trusted safe urls during img[src] sanitization.

The sanitization is a security measure aimed at prevent XSS attacks via HTML image src links.

Any URL due to be assigned to an `img[src]` attribute via interpolation is marked as requiring the $sce.MEDIA_URL security context. When interpolation occurs a call is made to `$sce.trustAsMediaUrl(url)` which in turn may call `$$sanitizeUri(url, isMedia)` to sanitize the potentially malicious URL.

If the URL matches the `imgSrcSanitizationTrustedUrlList` regular expression, it is returned unchanged.

If there is no match the URL is returned prefixed with `'unsafe:'` to ensure that when it is written to the DOM it is inactive and potentially malicious code will not be executed.

- Defined in core/sanitize/sanitize-uri.js:63